"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const events_1 = tslib_1.__importDefault(require("events"));
const common_1 = require("./common");
class QueuedJobEmitter extends events_1.default {
}
/**
 * @public
 */
class QueuedJobs extends common_1.QueuedJobsBase {
    constructor(maxQueueLength = 50, timeout = 30000, maxListeners = 100) {
        super(maxQueueLength, timeout);
        this.emitter = new QueuedJobEmitter();
        this.emitter.setMaxListeners(maxListeners);
    }
    dispatchEvent(eventName, data) {
        this.emitter.emit(eventName, data);
    }
    once(eventName, callback) {
        this.emitter.once(eventName, callback);
    }
    on(eventName, callback) {
        this.emitter.on(eventName, callback);
    }
}
exports.default = QueuedJobs;
